uk.gov.hmrc.ct.computations

# Building

###
Related Doc: package computations

#### case class Building(description: Option[String], firstLineOfAddress: Option[String], postcode: Option[String], earliestWrittenContract: Option[LocalDate], nonResidentialActivityStart: Option[LocalDate], costsClaimedInThisPeriod: Option[Boolean], cost: Option[Int], claim: Option[Int], broughtForward: Option[Int] = None, carriedForward: Option[Int] = None, claimNote: Option[String] = None) extends ValidatableBox[ComputationsBoxRetriever] with ExtraValidation with SBAHelper with SBACalculator with Product with Serializable

Linear Supertypes
Serializable, Serializable, Product, Equals, SBACalculator, AccountingPeriodHelper, NumberRounding, SBAHelper, ValidatableBox[ComputationsBoxRetriever], ExtraValidation, Validators, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Building
2. Serializable
3. Serializable
4. Product
5. Equals
6. SBACalculator
7. AccountingPeriodHelper
8. NumberRounding
9. SBAHelper
10. ValidatableBox
11. ExtraValidation
12. Validators
13. AnyRef
14. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Building(description: Option[String], firstLineOfAddress: Option[String], postcode: Option[String], earliestWrittenContract: Option[LocalDate], nonResidentialActivityStart: Option[LocalDate], costsClaimedInThisPeriod: Option[Boolean], cost: Option[Int], claim: Option[Int], broughtForward: Option[Int] = None, carriedForward: Option[Int] = None, claimNote: Option[String] = None)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def And(predicates: () ⇒ Boolean*)(): Boolean

   Attributes
     protected
   Definition Classes
     Validators

5. #### def Or(predicates: () ⇒ Boolean*)(): Boolean

   Attributes
     protected
   Definition Classes
     Validators

6. #### def accountingPeriodDaysInFinancialYear(year: Int, accountingPeriod: HmrcAccountingPeriod): BigDecimal

   Definition Classes
     AccountingPeriodHelper

7. #### def accountingPeriodSpansTwoFinancialYears(accountingPeriod: HmrcAccountingPeriod): Boolean

   Definition Classes
     AccountingPeriodHelper

8. #### def apportionedCostOfBuilding(cost: BigDecimal, daysInTheYear: Int, rateForTy: SBARateForTaxYear): BigDecimal

   Definition Classes
     SBACalculator

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def atLeastOneBoxHasValue(boxId: String, boxes: OptionalCtValue[_]*)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

11. #### def belowMin(value: Option[Int], min: Int = MIN_MONEY_AMOUNT_ALLOWED)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

12. #### val boxId: String

    Attributes
      protected
    Definition Classes
      Validators

13. #### val broughtForward: Option[Int]

14. #### val broughtForwardId: String

    Definition Classes
      SBAHelper

15. #### def cannotExistErrorIf(predicate: ⇒ Boolean)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

16. #### val carriedForward: Option[Int]

17. #### val carriedForwardId: String

    Definition Classes
      SBAHelper

18. #### val claim: Option[Int]

19. #### val claimId: String

    Definition Classes
      SBAHelper

20. #### val claimNote: Option[String]

21. #### val claimNoteId: String

    Definition Classes
      SBAHelper

22. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

23. #### def collectErrors(predicates: () ⇒ Set[CtValidation]*): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

24. #### def collectWithBoxId(newBoxId: String)(errors: Set[CtValidation]): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

25. #### val cost: Option[Int]

26. #### val costId: String

    Definition Classes
      SBAHelper

27. #### val costsClaimedInThisPeriod: Option[Boolean]

28. #### val dateLowerBound: LocalDate

    Definition Classes
      SBAHelper

29. #### def daysBetween(start: LocalDate, end: LocalDate): Int

    Definition Classes
      AccountingPeriodHelper

30. #### def daysInAccountingPeriod(accountingPeriod: HmrcAccountingPeriod): Int

    Definition Classes
      AccountingPeriodHelper

31. #### val description: Option[String]

32. #### val descriptionId: String

    Definition Classes
      SBAHelper

33. #### val earliestWrittenContract: Option[LocalDate]

34. #### val earliestWrittenContractId: String

    Definition Classes
      SBAHelper

35. #### def endingFinancialYear(date: EndDate): Int

    Definition Classes
      AccountingPeriodHelper

36. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

37. #### val exampleUpperBoundDate: LocalDate

    Definition Classes
      SBAHelper

38. #### def exceedsMax(value: Option[Int], max: Int = MAX_MONEY_AMOUNT_ALLOWED)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

39. #### def failIf(condition: ⇒ Boolean)(validationErrors: ⇒ Set[CtValidation])(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

40. #### val filingPeriodQuestionId: String

    Definition Classes
      SBAHelper

41. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

42. #### def financialYearForDate(date: LocalDate): Int

    Definition Classes
      AccountingPeriodHelper

43. #### def financialYearStartingIn(year: Int): (LocalDate, LocalDate)

    Definition Classes
      AccountingPeriodHelper

44. #### val firstLineOfAddress: Option[String]

45. #### val firstLineOfAddressId: String

    Definition Classes
      SBAHelper

46. #### def getApportionedRates(apStartDate: LocalDate, apEndDate: LocalDate): Int

47. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

48. #### def getDaysIntheYear(apStartDate: LocalDate): Int

    Definition Classes
      SBACalculator

49. #### def getSbaDetails(apStartDate: LocalDate, apEndDate: LocalDate, maybeFirstUsageDate: Option[LocalDate], maybeCost: Option[Int]): Option[SbaResults]

    Definition Classes
      SBACalculator

50. #### def isEarliestWrittenContractAfterAPStart(contractDate: LocalDate, apStartDate: LocalDate): Boolean

    Definition Classes
      SBACalculator

51. #### def isEmpty(value: Option[_]): Boolean

    Attributes
      protected
    Definition Classes
      Validators

52. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

53. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

54. #### def nonEmpty(value: Option[_]): Boolean

    Attributes
      protected
    Definition Classes
      Validators

55. #### val nonResActivityId: String

    Definition Classes
      SBAHelper

56. #### val nonResidentialActivityStart: Option[LocalDate]

57. #### final def notify(): Unit

    Definition Classes
      AnyRef

58. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

59. #### def passIf(condition: ⇒ Boolean)(validationErrors: ⇒ Set[CtValidation])(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

60. #### val postCodeRegex: String

    Attributes
      protected
    Definition Classes
      ExtraValidation

61. #### val postcode: Option[String]

62. #### val postcodeId: String

    Definition Classes
      SBAHelper

63. #### val rateAfterTy2020: SBARateForTaxYear

    Definition Classes
      SBACalculator

64. #### val ratePriorTy2020: SBARateForTaxYear

    Definition Classes
      SBACalculator

65. #### def replaceBoxId(newBoxId: String, errors: () ⇒ Set[CtValidation])(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

66. #### def requiredErrorIf(predicate: ⇒ Boolean)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

67. #### def roundedToInt(value: BigDecimal): Int

    Definition Classes
      NumberRounding

68. #### def roundedToIntHalfDown(value: BigDecimal): Int

    Definition Classes
      NumberRounding

69. #### def roundedToIntHalfUp(value: BigDecimal): Int

    Definition Classes
      NumberRounding

70. #### def roundedTwoDecimalPlaces(value: BigDecimal): BigDecimal

    Definition Classes
      NumberRounding

71. #### val sba01BoxId: String

    Definition Classes
      SBAHelper

72. #### def startingFinancialYear(date: StartDate): Int

    Definition Classes
      AccountingPeriodHelper

73. #### def sumAmount(xs: List[Option[Int]]): Option[Int]

    Definition Classes
      SBACalculator

74. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

75. #### def validate(boxRetriever: ComputationsBoxRetriever): Set[CtValidation]

    Definition Classes
      Building → ValidatableBox

76. #### def validateAccountingPeriod(accountingPeriod: HmrcAccountingPeriod): Unit

    Definition Classes
      AccountingPeriodHelper

77. #### def validateAllFilledOrEmptyStrings(boxId: String, allBoxes: Set[CtValue[String]])(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

78. #### def validateAllFilledOrEmptyStringsForBankDetails(boxRetriever: RepaymentsBoxRetriever, boxId: String)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

79. #### def validateAsMandatory[U](box: CtValue[U] with CtBoxIdentifier)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

80. #### def validateAsMandatory[A](boxId: String, value: Option[A])(): Set[CtValidation]

    Definition Classes
      ExtraValidation

81. #### def validateBooleanAsMandatory(boxId: String, box: OptionalBooleanIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

82. #### def validateBooleanAsTrue(boxId: String, box: OptionalBooleanIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

83. #### def validateCoHoStringReturnIllegalChars(boxId: String, value: String, errorCodeBoxId: Option[String] = None)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

84. #### def validateCoHoStringReturnIllegalChars(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

85. #### def validateCohoNameField(boxId: String, box: StringIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

86. #### def validateCohoOptionalNameField(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

87. #### def validateDateAsAfter(boxId: String, box: OptionalDateIdBox, dateToCompare: LocalDate)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

88. #### def validateDateAsBefore(boxId: String, box: OptionalDateIdBox, dateToCompare: LocalDate)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

89. #### def validateDateAsBetweenInclusive(boxId: String, date: Option[LocalDate], minDate: LocalDate, maxDate: LocalDate, messageId: String)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

90. #### def validateDateAsBetweenInclusive(boxId: String, box: OptionalDateIdBox, minDate: LocalDate, maxDate: LocalDate)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

91. #### def validateDateAsBlank(boxId: String, box: OptionalDateIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

92. #### def validateDateAsMandatory(boxId: String, date: Option[LocalDate], messageId: String)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

93. #### def validateDateAsMandatory(boxId: String, box: OptionalDateIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

94. #### def validateDateIsInclusive(boxId: String, minDate: LocalDate, dateToCompare: Option[LocalDate], maxDate: LocalDate): Set[CtValidation]

    Definition Classes
      ExtraValidation

95. #### def validateIntegerAsBlank(boxId: String, box: OptionalIntIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

96. #### def validateIntegerAsMandatory(boxId: String, box: OptionalIntIdBox)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

97. #### def validateIntegerRange(boxId: String, box: OptionalIntIdBox, min: Int, max: Int)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      ValidatableBox

98. #### def validateMoney(value: Option[Int], min: Int = 99999999, max: Int = 99999999)(): Set[CtValidation]

    Attributes
      protected
    Definition Classes
      Validators

99. #### def validateNotEmptyStringByLength(boxId: String, value: String, min: Int, max: Int)(): Set[CtValidation]

    Definition Classes
      ValidatableBox

100. #### def validateOptionalIntegerAsEqualTo(box: CtBoxIdentifier with CtOptionalInteger, equalToBox: CtBoxIdentifier with CtOptionalInteger): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

101. #### def validateOptionalStringByLength(boxId: String, box: OptionalStringIdBox, min: Int, max: Int)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

102. #### def validateOptionalStringByLength(value: Option[String], min: Int, max: Int, boxId: String, boxIdPrefix: Option[String])(): Set[CtValidation]

     Definition Classes
       ExtraValidation

103. #### def validateOptionalStringByRegex(boxId: String, box: OptionalStringIdBox, regex: String)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

104. #### def validatePositiveBigDecimal(box: OptionalBigDecimalIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

105. #### def validatePositiveInteger(box: OptionalIntIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

106. #### def validatePostcode(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

     Definition Classes
       ValidatableBox

107. #### def validatePostcode(boxId: String, postcode: Option[String]): Set[CtValidation]

     Definition Classes
       ExtraValidation

108. #### def validatePostcodeLength(boxId: String, postcode: String): Set[CtValidation]

     Definition Classes
       ExtraValidation

109. #### def validatePostcodeRegex(boxId: String, postcode: String): Set[CtValidation]

     Definition Classes
       ExtraValidation

110. #### def validateRawStringByRegex(boxId: String, value: String, errorCodeBoxId: String, regex: String)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

111. #### def validateStringAsBlank(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

112. #### def validateStringAsMandatory(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

113. #### def validateStringAsMandatoryIfPAYEEQ1False(boxRetriever: RepaymentsBoxRetriever, boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

114. #### def validateStringAsMandatoryWithNoTrailingWhitespace(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

115. #### def validateStringByLength(boxId: String, value: String, errorCodeId: String, min: Int, max: Int)(): Set[CtValidation]

     Definition Classes
       ValidatableBox

116. #### def validateStringByLength(boxId: String, box: StringIdBox, min: Int, max: Int)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

117. #### def validateStringByRegex(boxId: String, box: StringIdBox, regex: String)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

118. #### def validateStringByRegex(boxId: String, str: String, regex: String): Set[CtValidation]

     Definition Classes
       ExtraValidation

119. #### def validateStringMaxLength(boxId: String, value: String, max: Int)(): Set[CtValidation]

     Definition Classes
       ValidatableBox

120. #### def validateZeroOrNegativeInteger(box: OptionalIntIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

121. #### def validateZeroOrPositiveBigDecimal(box: OptionalBigDecimalIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

122. #### def validateZeroOrPositiveInteger(box: OptionalIntIdBox)(): Set[CtValidation]

     Attributes
       protected
     Definition Classes
       ValidatableBox

123. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

124. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

125. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

### Inherited from Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from SBACalculator

### Inherited from AccountingPeriodHelper

### Inherited from NumberRounding

### Inherited from SBAHelper

### Inherited from ValidatableBox[ComputationsBoxRetriever]

### Inherited from ExtraValidation

### Inherited from Validators

### Inherited from AnyRef

### Inherited from Any

### Ungrouped